public class KungFuMan {
	/**
	 * An opponent of this KungFuMan.
	 */
	private Object opponent;

	/**
	 * Life point.
	 */
	private int life;
	private int maxLife =100;

	/**
	 * Strength, combining with defence must not exceed 100.
	 */
	private int strength;

	/**
	 * Defence, combining with strength must not exceed 100.
	 */
	private int defence;

	/**
	 * Heavier move requires longer time to recover. While Recovering, the
	 * character cannot attack.
	 */
	private int recoverTimeFromOwnMove;

	public KungFuMan(Object opponent) {
		super();
		this.opponent = opponent;
		life = 100;
		strength = 50; //strength + defence == 100  always
		defence = 50;
		recoverTimeFromOwnMove = 0;
	}

	/**
	 * Get a reference to the current opponent.
	 *
	 * @return opponent.
	 */
	public Object getOpponent() {
		return opponent;
	}

	/**
	 * Assign a given KungFuMan to be the current opponent.
	 *
	 * @param opponent
	 */
	public void setOpponent(Object opponent) {
		this.opponent = opponent;
	}

	public int getLife() {
		return life;
	}

	public void setLife(int life) {
		this.life = life;
	}

	public int getMaxLife() {
		return maxLife;
	}

	public void setMaxLife(int life) {
		this.maxLife = life;
	}

	public int getStrength() {
		return strength;
	}

	public void setStrength(int strength) {
		this.strength = strength;
	}

	public int getDefence() {
		return defence;
	}

	public void setDefence(int defence) {
		this.defence = defence;
	}

	public int getRecoverTimeFromOwnMove() {
		return recoverTimeFromOwnMove;
	}

	public void setRecoverTimeFromOwnMove(int recoverTimeFromOwnMove) {
		this.recoverTimeFromOwnMove = recoverTimeFromOwnMove;
	}

	/**
	 * If not recovering, always attack with attack type 3.
	 */
	public void move() {
		if (recoverTimeFromOwnMove == 0)
			attack(3);
		else
			recoverTimeFromOwnMove -= 1;
	}

	/**
	 * Reduce the life point after being attacked.
	 *
	 * @param attackLevel
	 *            indicates the level of attack: 1 -> light 2-> medium 3 ->
	 *            heavy
	 */
	public void attacked(int attackLevel) {
		life = life - (attackLevel * ((KungFuMan) opponent).strength / defence);
	}

	/**
	 * Attack opponent with given type of attack (from 1 to 7). Resulting in
	 * opponent calling method attacked().
	 *
	 * @param attackType
	 *            the moves that this possesses.
	 */
	public void attack(int attackType) {
		recoverTimeFromOwnMove = attackType;

		switch (attackType) {
		case 1:
			((KungFuMan) opponent).attacked(1);
			System.out.println(" straight light punch.");
			break;

		case 2:
			((KungFuMan) opponent).attacked(1);
			System.out.println(" straight light kick.");
			break;

		case 3:
			((KungFuMan) opponent).attacked(2);
			System.out.println(" straight medium punch.");
			break;

		case 4:
			((KungFuMan) opponent).attacked(2);
			System.out.println(" straight medium kick.");
			break;

		case 5:
			((KungFuMan) opponent).attacked(3);
			System.out.println(" straight heavy punch.");
			break;

		case 6:
			((KungFuMan) opponent).attacked(3);
			System.out.println(" straight heavy kick.");
			break;

		case 7:
			((KungFuMan) opponent).attacked(3);
			System.out.println(" Roundhouse heavy kick.");
			break;

		default:
			System.out.println(" Move failed!");
			break;
		}
	}

}
